#pragma once
#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASListNameSearch : public CWASCommand
{
public:
	CWASListNameSearch(CWASActor *pActor);
	~CWASListNameSearch(void);

	void ExecuteAsync(void);

	void SetParameter(const NE_SEARCH_MEMBER_PARAM& searchParam)
	{
		m_param = searchParam;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);


private:
	// Input parameters
	NE_SEARCH_MEMBER_PARAM m_param;

	// Resaults
	size_t m_nSearchTotal;
	size_t m_nRetPage;
	std::vector<NE_MEMBER_DATA> m_listResultPrivate;
	std::vector<NE_MEMBER_DATA> m_listResult;

};
